/******************************************************************/

#include "system.h"
#include "filosofo.h"

/****************************************************/

	int sem_create(int,int);
	int sem_open(int);
	int sem_close(int);
	int sem_rm(int);
	int sem_wait(int);
	int sem_signal(int);

/****************************************************/
	int sem_create(int,int){return(0);}
	int sem_open(int){return(0);}
	int sem_close(int){return(0);}
	int sem_rm(int){return(0);}
	int sem_wait(int){return(0);}
	int sem_signal(int){return(0);}

/******************************************************************/

	int IdSharedMem;
	DatosGlobalesType* DatosGlobales;


	int IdSemaf;


/******************************************************************/
void CreateSharedMem(void)
{
	IdSharedMem=shmget(SHARED_KEY,sizeof(DatosGlobalesType),0777|IPC_CREAT);
	Assert(IdSharedMem!=-1);

	IdSemaf=sem_create(SHARED_KEY+1,0);
	Assert(IdSemaf!=-1);
}

/******************************************************************/
void  AttachSharedMem(void)
{
	DatosGlobales=(DatosGlobalesType*)shmat(IdSharedMem,0,0);
	Assert(DatosGlobales!=NULL);

	IdSemaf=sem_open(SHARED_KEY+1);
	Assert(IdSemaf!=-1);
}

/******************************************************************/
void  DettachSharedMem(void)
{
	shmdt((char*)DatosGlobales);
	sem_close(IdSemaf);
}

/******************************************************************/
void DestroySharedMem(void)
{
	shmctl(IdSharedMem,IPC_RMID,0);
	sem_rm(IdSemaf);
}

/******************************************************************/
void WaitSemaf(void)
{
	sem_wait(IdSemaf);
}

/******************************************************************/
void SignalSemaf(void)
{
	sem_signal(IdSemaf);
}

/******************************************************************/
/******************************************************************/
/******************************************************************/
/******************************************************************/


